import allNames from './utils/all-names';
const cleaner = (instance, container, name) => {
    container[name] = null;
};
const decorateFactory = (factory) => [
    factory,
    cleaner,
];
const decorateTupple = ([factory, initilizer]) => [
    factory,
    (instance, container, name) => {
        initilizer(instance, container, name);
        cleaner(instance, container, name);
    },
];
const decorateItemBinding = (itemBinding) => (typeof itemBinding === 'function'
    ? decorateFactory(itemBinding)
    : decorateTupple(itemBinding));
const decorateFactories = (factories) => allNames(factories).reduce((newObject, name) => Object.defineProperty(newObject, name, Object.assign(Object.assign({}, Object.getOwnPropertyDescriptor(factories, name)), { value: decorateItemBinding(factories[name]) })), Object.create(null));
const multiple = (bindingOrFactories) => (!Array.isArray(bindingOrFactories) && typeof bindingOrFactories === 'object'
    ? decorateFactories(bindingOrFactories)
    : decorateItemBinding(bindingOrFactories));
export default multiple;
