"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _push = function (stack, set) { return function (item) {
    if (set.has(item))
        return [new Error('Duplicated item has been pushed to the stack.'), null];
    stack.unshift(item);
    set.add(item);
    return [null, item];
}; };
var _pop = function (stack, set) { return function (expected) {
    if (stack.length === 0) {
        return [new Error('Trying to extract item from the empty stack'), null];
    }
    var last = stack.shift();
    set.delete(last);
    return (expected === undefined || last === expected
        ? [null, last]
        : [new Error('Extracted item is not equal to expected one'), null]);
}; };
var UniqueStackApi = function (stack, set) { return ({
    push: _push(stack, set),
    pop: _pop(stack, set),
    get size() {
        return stack.length;
    },
}); };
var UniqueStack = function () { return UniqueStackApi([], new Set()); };
exports.default = UniqueStack;
